<?php
/**
 * Wima nouveau
 *
 * Translated from gwicke's previous TAL template version to remove
 * dependency on PHPTAL.
 *
 * @todo document
 * @file
 * @ingroup Skins
 */

if( !defined( 'MEDIAWIKI' ) )
	die( -1 );

/**
 * Inherit main code from SkinTemplate, set the CSS and template filter.
 * @todo document
 * @ingroup Skins
 */
class SkinWima extends SkinTemplate {
	/** Using wima. */
	var $skinname = 'wima', $stylename = 'wima',
		$template = 'WimaTemplate', $useHeadElement = true;

	/**
	 * @param $out OutputPage
	 */
	function setupSkinUserCss( OutputPage $out ) {
		global $wgHandheldStyle;
		parent::setupSkinUserCss( $out );

		$out->addModuleStyles( 'skins.wima' );

		// Ugh. Can't do this properly because $wgHandheldStyle may be a URL
		if( $wgHandheldStyle ) {
			// Currently in testing... try 'chick/main.css'
			$out->addStyle( $wgHandheldStyle, 'handheld' );
		}

		// TODO: Migrate all of these
		$out->addStyle( 'wima/IE60Fixes.css', 'screen', 'IE 6' );
		$out->addStyle( 'wima/IE70Fixes.css', 'screen', 'IE 7' );

	}
}

/**
 * @todo document
 * @ingroup Skins
 */
class WimaTemplate extends BaseTemplate {

	/**
	 * Template filter callback for Wima skin.
	 * Takes an associative array of data set from a SkinTemplate-based
	 * class, and a wrapper for MediaWiki's localization database, and
	 * outputs a formatted page.
	 *
	 * @access private
	 */
	function execute() {
		// Suppress warnings to prevent notices about missing indexes in $this->data
		wfSuppressWarnings();

		$this->html( 'headelement' );
?><div id="globalWrapper">
<div id="column-content"><div id="content">
	<a id="top"></a>
	<?php $this->getSitenoticeOrAdvertisementBox(); ?>

	<h1 id="firstHeading" class="firstHeading"><span dir="auto"><?php $this->html('title') ?></span></h1>
	<div id="bodyContent" class="mw-body">
		<div id="siteSub"><?php $this->msg('tagline') ?></div>
		<div id="contentSub"<?php $this->html('userlangattributes') ?>><?php $this->html('subtitle') ?></div>
<?php if($this->data['undelete']) { ?>
		<div id="contentSub2"><?php $this->html('undelete') ?></div>
<?php } ?><?php if($this->data['newtalk'] ) { ?>
		<div class="usermessage"><?php $this->html('newtalk')  ?></div>
<?php } ?><?php if($this->data['showjumplinks']) { ?>
		<div id="jump-to-nav" class="mw-jump"><?php $this->msg('jumpto') ?> <a href="#column-one"><?php $this->msg('jumptonavigation') ?></a>, <a href="#searchInput"><?php $this->msg('jumptosearch') ?></a></div>
<?php } ?>
		<!-- start content -->
<?php $this->html('bodytext') ?>
		<?php if($this->data['catlinks']) { $this->html('catlinks'); } ?>
		<!-- end content -->
		<?php if($this->data['dataAfterContent']) { $this->html ('dataAfterContent'); } ?>
		<div class="visualClear"></div>
	</div>
	<?php $this->getAdvertisementBoxUnten(); ?>
</div></div>
<div id="column-one"<?php $this->html('userlangattributes')  ?>>
<?php $this->cactions(); ?>
	<div class="portlet" id="p-personal">
		<h5><?php $this->msg('personaltools') ?></h5>
		<div class="pBody">
			<ul<?php $this->html('userlangattributes') ?>>
<?php		foreach($this->getPersonalTools() as $key => $item) { ?>
				<?php echo $this->makeListItem($key, $item); ?>

<?php		} ?>
			</ul>
		</div>
	</div>
	<div class="portlet" id="p-logo">
<?php
			echo Html::element( 'a', array(
				'href' => $this->data['nav_urls']['mainpage']['href'],
				'style' => "background-image: url({$this->data['logopath']});" )
				+ Linker::tooltipAndAccesskeyAttribs('p-logo') ); ?>

	</div>
<?php
	$this->renderPortals( $this->data['sidebar'] );
?>
</div><!-- end of the left (by default at least) column -->
<div class="visualClear"></div>
<?php
	$validFooterIcons = $this->getFooterIcons( "icononly" );
	$validFooterLinks = $this->getFooterLinks( "flat" ); // Additional footer links

	if ( count( $validFooterIcons ) + count( $validFooterLinks ) > 0 ) { ?>
<div id="footer"<?php $this->html('userlangattributes') ?>>
<?php
		$footerEnd = '</div>';
	} else {
		$footerEnd = '';
	}
	foreach ( $validFooterIcons as $blockName => $footerIcons ) { ?>
	<div id="f-<?php echo htmlspecialchars($blockName); ?>ico">
<?php foreach ( $footerIcons as $icon ) { ?>
		<?php echo $this->getSkin()->makeFooterIcon( $icon ); ?>

<?php }
?>
	</div>
<?php }

		if ( count( $validFooterLinks ) > 0 ) {
?>	<ul id="f-list">
<?php
			foreach( $validFooterLinks as $aLink ) { ?>
		<li id="<?php echo $aLink ?>"><?php $this->html($aLink) ?></li>
<?php
			}
?>
	</ul>
<?php	}
echo $footerEnd;
?>

</div>
<?php
		$this->printTrail();
		echo Html::closeElement( 'body' );
		echo Html::closeElement( 'html' );
		wfRestoreWarnings();
	} // end of execute() method

	/*************************************************************************************************/

	protected function renderPortals( $sidebar ) {
		if ( !isset( $sidebar['SEARCH'] ) ) $sidebar['SEARCH'] = true;
		if ( !isset( $sidebar['TOOLBOX'] ) ) $sidebar['TOOLBOX'] = true;
		if ( !isset( $sidebar['LANGUAGES'] ) ) $sidebar['LANGUAGES'] = true;

		foreach( $sidebar as $boxName => $content ) {
			if ( $content === false )
				continue;

			if ( $boxName == 'SEARCH' ) {
				$this->searchBox();
			} elseif ( $boxName == 'TOOLBOX' ) {
				$this->toolbox();
			} elseif ( $boxName == 'AD1' ) {
				$this->getAdvertisementSidebarOben();
			} elseif ( $boxName == 'AD2' ) {
				$this->getAdvertisementSidebarUnten();
			} elseif ( $boxName == 'LANGUAGES' ) {
				$this->languageBox();
			} else {
				$this->customBox( $boxName, $content );
			}
		}
		$this->getDonationBox();
	}

	function searchBox() {
		global $wgUseTwoButtonsSearchForm;
?>
	<div id="p-search" class="portlet">
		<h5><label for="searchInput"><?php $this->msg('search') ?></label></h5>
		<div id="searchBody" class="pBody">
			<form action="<?php $this->text('wgScript') ?>" id="searchform">
				<input type='hidden' name="title" value="<?php $this->text('searchtitle') ?>"/>
				<?php echo $this->makeSearchInput(array( "id" => "searchInput" )); ?>

				<?php echo $this->makeSearchButton("go", array( "id" => "searchGoButton", "class" => "searchButton" ));
				if ($wgUseTwoButtonsSearchForm): ?>&#160;
				<?php echo $this->makeSearchButton("fulltext", array( "id" => "mw-searchButton", "class" => "searchButton" ));
				else: ?>

				<div><a href="<?php $this->text('searchaction') ?>" rel="search"><?php $this->msg('powersearch-legend') ?></a></div><?php
				endif; ?>

			</form>
		</div>
	</div>
<?php
	}

	/**
	 * Prints the cactions bar.
	 * Shared between Wima, MonoBook and Modern
	 */
	function cactions() {
?>
	<div id="p-cactions" class="portlet">
		<h5><?php $this->msg('views') ?></h5>
		<div class="pBody">
			<ul><?php
				foreach($this->data['content_actions'] as $key => $tab) {
					echo '
				' . $this->makeListItem( $key, $tab );
				} ?>

			</ul>
		</div>
	</div>
<?php
	}
	/*************************************************************************************************/
	function toolbox() {
?>
	<div class="portlet" id="p-tb">
		<h5><?php $this->msg('toolbox') ?></h5>
		<div class="pBody">
			<ul>
<?php
		foreach ( $this->getToolbox() as $key => $tbitem ) { ?>
				<?php echo $this->makeListItem($key, $tbitem); ?>

<?php
		}
		wfRunHooks( 'WimaTemplateToolboxEnd', array( &$this ) );
		wfRunHooks( 'SkinTemplateToolboxEnd', array( &$this, true ) );
?>
			</ul>
		</div>
	</div>
<?php
	}

	/*************************************************************************************************/
	function languageBox() {
		if( $this->data['language_urls'] ) {
?>
	<div id="p-lang" class="portlet">
		<h5<?php $this->html('userlangattributes') ?>><?php $this->msg('otherlanguages') ?></h5>
		<div class="pBody">
			<ul>
<?php		foreach($this->data['language_urls'] as $key => $langlink) { ?>
				<?php echo $this->makeListItem($key, $langlink); ?>

<?php		} ?>
			</ul>
		</div>
	</div>
<?php
		}
	}

	/*************************************************************************************************/
	function customBox( $bar, $cont ) {
		$portletAttribs = array( 'class' => 'generated-sidebar portlet', 'id' => Sanitizer::escapeId( "p-$bar" ) );
		$tooltip = Linker::titleAttrib( "p-$bar" );
		if ( $tooltip !== false ) {
			$portletAttribs['title'] = $tooltip;
		}
		echo '	' . Html::openElement( 'div', $portletAttribs );
?>

		<h5><?php $msg = wfMessage( $bar ); echo htmlspecialchars( $msg->exists() ? $msg->text() : $bar ); ?></h5>
		<div class='pBody'>
<?php   if ( is_array( $cont ) ) { ?>
			<ul>
<?php 			foreach($cont as $key => $val) { ?>
				<?php echo $this->makeListItem($key, $val); ?>

<?php			} ?>
			</ul>
<?php   } else {
			# allow raw HTML block to be defined by extensions
			print $cont;
		}
?>
		</div>
	</div>
<?php
	}

	/**
	 * Renderer for advertisement block
	 *
	 * @return string html
	 */
	protected function getSitenoticeOrAdvertisementBox() {
		global $wgTopBannerCode;
		$issetSitenoticeBox    = $this->data['sitenotice'];
		$issetAdvertisementBox = isset($wgTopBannerCode);

		if ($issetSitenoticeBox && $issetAdvertisementBox) {
			if ( rand(0, 1) ) {
				$this->getSitenoticeBox();
			} else {
				$this->getAdvertisementBoxOben();
			}
		} elseif ($issetSitenoticeBox) {
			$this->getSitenoticeBox();
		} elseif ($issetAdvertisementBox) {
			$this->getAdvertisementBoxOben();
		}

		return;
	}
	protected function getSitenoticeBox() {
		echo '<div id="siteNotice">' . $this->html( "sitenotice" ) . '</div>';
		return;
	}
	protected function getAdvertisementBoxOben() {
		global $wgTopBannerCode, $wgTopBannerStyle, $wgTopBannerType;
		$html = '';
		if (isset($wgTopBannerCode)) {
			$msg_key = isset($wgTopBannerType) ? $wgTopBannerType : "advertising";
			$css_key = isset($wgTopBannerStyle) ? $wgTopBannerStyle : "text-align:center; border:1px solid red;";
			$html = '<div id="p-Werbung-Oben" title="Link mit Skripte" style="text-align:left;">'
		    	  . $this->getMsg( $msg_key ).':'
			      . '<div style="'.$css_key.'">'
			      . $wgTopBannerCode
			      . '</div></div>';
		}

		echo $html;
		return;
	}
	protected function getAdvertisementBoxUnten() {
		global $wgBottomBannerCode, $wgBottomBannerStyle;
		$html = '';
		if (isset($wgBottomBannerCode)) {
			$msg_key = "advertising";
			$css_key = isset($wgBottomBannerStyle) ? $wgBottomBannerStyle : "text-align:center; border:0;";
			$html = '<div id="p-Werbung-Unten" title="Link mit Skripte" style="text-align:left; margin-top:1em;">'
			      . $this->getMsg( $msg_key ).':'
			      . '<div style="'.$css_key.'">'
			      . $wgBottomBannerCode
			      . '</div></div>';
		}

		echo $html;
		return;
	}
	protected function getAdvertisementSidebarOben() {
		global $wgAdSidebarTopCode, $wgAdSidebarStyle, $wgAdSidebarTopType;
		$html = '';
		if (isset($wgAdSidebarTopCode)) {
			$msg_key = isset($wgAdSidebarTopType) ? $wgAdSidebarTopType : "advertising";
			$css_key = isset($wgAdSidebarStyle) ? $wgAdSidebarStyle : "text-align:center;";
			$html = '<div class="generated-sidebar portlet" id="p-Werbung-Sidebar-Oben" style="display:block;">'
			      . '<h5>' . $this->getMsg( $msg_key ) . '</h5>'
			      . '<div title="Reiner Link ohne Skripte" class="thumbinner" style="'.$css_key.'">'
			      . $wgAdSidebarTopCode
			      . '</div></div>';
		}

		echo $html;
		return;
	}
	protected function getAdvertisementSidebarUnten() {
		global $wgAdSidebarBottomCode, $wgAdSidebarStyle;
		$html = '';
		if (isset($wgAdSidebarBottomCode)) {
			$msg_key = "advertising";
			$css_key = isset($wgAdSidebarStyle) ? $wgAdSidebarStyle : "text-align:center;";
			$html = '<div class="generated-sidebar portlet" id="p-Werbung-Sidebar-Unten" style="display:block;">'
			      . '<h5>' . $this->getMsg( $msg_key ) . '</h5>'
			      . '<div title="Reiner Link ohne Skripte" class="thumbinner" style="'.$css_key.'">'
			      . $wgAdSidebarBottomCode
			      . '</div></div>';
		}

		echo $html;
		return;
	}

	/**
	 * Renderer for donation block
	 *
	 * @return string html
	 */
	protected function getDonationBox() {
		global $wgDonationButton, $wgDonationButtonURL;
		$html = '';

		if (!isset($wgDonationButton) || $wgDonationButton) {
			$html = '<div class="generated-sidebar portlet" id="p-donations">';
			$html .= '<h5 id="p-donations-label">'.$this->getMsg( "donations" ).'</h5>';
			$html .= '<div title="Reiner Link ohne Skripte" style="text-align:center;">';
			if (isset($wgDonationButtonURL)) {
				$html .= '<a href="//'.$wgDonationButtonURL.$this->getMsg( "lang" ).'"><img src="//'.$this->getMsg( "lang" ).'.wikimannia.org/images/Donate_Button.gif" width="92" height="26" alt="Donate-Button"></a>';
			} else {
				$html .= '<img src="//'.$this->getMsg( "lang" ).'.wikimannia.org/images/Donate_Button.gif" width="92" height="26" alt="Donate-Button">';
			}
			$html .= '</div></div>';
		}

		echo $html;
		return;
	}
} // end of class
